﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="WebApplication1._Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title></title>
    <script type="text/javascript">

        // XMLHttpRequest
        var cliquesXR = 0;
        
        function TesteXmlHttpRequest() {
            cliquesXR += 1;
            var xmlHttpReq = createXMLHttpRequest();
            xmlHttpReq.open("GET", "Handler1.ashx?Cliques=" + cliquesXR, false);
            xmlHttpReq.send(null);
            alert(xmlHttpReq.responseText);
            
        }

        function createXMLHttpRequest() {
            try { return new XMLHttpRequest(); } catch (e) { }
            try { return new ActiveXObject("Msxml2.XMLHTTP"); } catch (e) { }
            try { return new ActiveXObject("Microsoft.XMLHTTP"); } catch (e) { }
            alert("XMLHttpRequest not supported");
            return null;
        }
        // Fim XMLHttpRequest

        //Pagemethods

        var cliquesPM = 0;

        function TestePageMethods() {
            cliquesPM += 1;
            PageMethods.RetornaPageMethod(cliquesPM, oncompletePM);
        }

        function oncompletePM(valor) {
            alert(valor);
        }

        //Fim Pagemethods


        //WebService
        var cliquesWS = 0;

        function TesteWebService() {
            cliquesWS += 1;
            WebApplication1.WebService1.HelloWorld(cliquesWS,completoWebservice);
        }

        function completoWebservice(valor) {
            alert(valor);
        }
        
        //Fim WebService
        
    </script>
</head>
<body>
    <form id="form1" runat="server">
    
    <div>
     <h3>Comunicação entre cliente e servidor</h3>
     <h5>Sem Ajax: Qualquer controlo que faça PostBack vai ao servidor e regressa ao cliente</h5>
            
        <asp:button ID="Button1" runat="server" text="Button" onclick="Button1_Click" />
        <asp:TextBox ID="TextBox1" runat="server"></asp:TextBox>
        
        <h5>Com Ajax: XMLHttpRequest / PageMethods / WebServices / UpdatePanel</h5>
        
        XMLHttpRequest: <br />
        <input id="Button2" type="button" value="Teste XMLHttpRequest" onclick="TesteXmlHttpRequest();" />
        <br />
        
        PageMethods:<br />
        <input id="Button3" type="button" value="Teste PageMethods" onclick="TestePageMethods();" />
        <asp:ScriptManager ID="ScriptManager1" runat="server" EnablePageMethods="true">
            <Services>
            <asp:ServiceReference Path="~/WebService1.asmx" />
            </Services>
        </asp:ScriptManager>
        <br />
        
        UpdatePanel:
        <asp:UpdatePanel ID="UpdatePanel1" runat="server">
        <ContentTemplate>
            <asp:button ID="Button4" runat="server" text="Teste UpdatePanel" 
                onclick="Button4_Click"/>
            <asp:TextBox ID="TextBox2" runat="server" Width="197px"></asp:TextBox>
        </ContentTemplate>
        </asp:UpdatePanel>
        
        WebService:<br />
        <input id="Button5" type="button" value="Teste WebService" onclick="TesteWebService();" />
        
    </div>
    </form>
</body>
</html>

